# 视频基础概念术语
#### 目录介绍



#### **目录介绍**
- **1.Codec基本含义**
- 1.1 什么是Codec
- 1.2 什么是编码和解码
- 1.3 为什么视频要编解码
- 1.4 音视频Codec的区别
- 1.5 Codec编解码API封装
- **2.视频容器文件**
- 2.1 什么是视频容器文件
- 2.2 什么是轨道
- **3.自适应视频播放技术**
- 3.1 什么叫自适应视频播放
- 3.2 如何实现该技术
- 3.3 自适应视频播放的规范
- **4.视频文件基本概念**
- 4.1 帧率
- 4.2 分辨率
- 4.3 码率
- 4.4 这些概念联系


### 1.Codec基本含义
#### 1.1 什么是Codec
- 一说到视频，音频，大家肯定都听说，至少有所耳闻这两个词编码（encode）和解码(decode)。
- **这里提到的Codec就是一种程序，这种程序可以对视频文件进行编码和解码。**

#### 1.2 什么是编码和解码
- 编码就是压缩
- 解码就是解压缩。

#### 1.3 为什么视频要编解码
- 视频文件的本质其实就是图片的集合而已，当一段连续的图片不断的出现在人眼前(一般一个连贯的电影或者动画至少要求一秒24帧，也就是一秒内连续出现24张图片)，肉眼就会“欺骗性”的告诉大脑我们在看一个视频，而不是幻灯片。
- 那假设一张像素为1280X720(清晰度，宽1280个像素点，高720个像素点)的图片，大小为约为1280X720X3 bytes,就是2.7MB。大家可以猜想一下为何我这里还需要乘以一个数字3.那么一段60秒钟的小电影，就需要60X24（24张图片）X2.7MB ，约为3.9GB了！
- Codec这种程序就出现了，它会把这些连续的图片们通过一定的算法压缩成体积更小的文件格式，这就是我们所谓的编码，压缩。但是在播放器的客户端，不管是PC，手机也好，他们要显示在屏幕上的，必须是实实在在的图片啊，所以这些被压缩过的文件最终又必须被还原成图片格式，这就是解码，解压缩。

#### 1.4 音视频Codec的区别
- Codec的编码与解码包含对视频数据的编码解码和音频数据的编码解码,因为音频的本质是声波信息，视频是图片处理，他们本质上是不同的。

#### 1.5 Codec编解码API封装
- Codec是一套程序，它遵循不同的规范，根据规范的不同提供不同的压缩解压缩策略。既然是一套规范，那么就肯定需要实现啊！在安卓平台里面，谷歌提供了视频编码解码的API，对一些基础的编码解码规范做了API的封装。


### 2.视频容器文件
#### 2.1 什么是视频容器文件
- 视频文件严格的来讲，他们应该被叫做容器文件。因为一个容器里，不仅仅包括了视频(video)数据，还包括了(audio)音频数据，有的容器还内嵌字幕，那么就还有文字(Text)数据。它说到底也就是一个结构化的文件而已。之所以说它结构化，就是它包含的视频，音频，文字数据都必须按照一定的规范，放在文件指定的位置(方便播放器解析)。

#### 2.2 什么是轨道
- 一个专业术语，用来区分不同的音视频/文字数据。但是MP4文件里面最重要的却是这个MetaData，它包含了很多关于视频的原始数据，比如视频的大小，视频的时长，还有一个索引表，这个索引表包含了不同轨道的起始位置(以字节为单位)，又因为每个轨道会被分成若干块sample(采样，每一块采样都是可以单独被播放器播放的一段数据，以微妙为单位)，metadata也会维护一个细粒度更小的索引表，记录了每一块sample的大小，起始位置，对应视频的时间是多少(以字节为单位)等等的信息。
- 举个简单的例子，有些电影包含粤语，国语两个声道。我们想换声道的时候会告诉播放器，我想听粤语，那么播放器会去索引表查找粤语的轨道起始位置，并且源源不断的读取粤语音轨的数据并播放出来。


### 3.自适应视频播放技术
#### 3.1 什么叫自适应视频播放
- 在在线视频播放中，最重要的一个要素应该就属于客户端的网络状况了，如果网络状况很差，俗称的网速很慢，那么大家一般的体验都是视频很卡，看一会就停一会。那么有没有可能让我们的播放器自动检测网络状况，在网络差的情况下播放清晰度较差，数据量较小的视频，当网络情况变得好的时候播放清晰度好，但是数据量大的视频呢？


#### 3.2 如何实现该技术
- 自适应播放技术一般包括前端的支持还有后台的支持，后台提供一个索引表(Manifest)，上面记录了同一个视频不同清晰度的版本的Url（比如视频的240p，480p，720p不同的版本文件）。前端的播放器在拿到这个索引表之后，会根据自身的网络状态，在不同清晰度直接的视频文件转换。


#### 3.3 自适应视频播放的规范
- 一个叫DASH的规范最为流行，我们这次以DASH这个规范来深入了解一下自适应视频播放的一些细节。
- **3.3.1 DASH里面的MPD文件**
- MPD文件格式，就是我们在第一部分中说到的索引表Manifest了(HLS对应的索引表格式叫M3u8),它包含了所有DASH自适应视频的信息。
- 每个mpd文件都会有至少一个adaptionset,用来记录音频/视频文件们的位置，如上图所示，该MPd有两组数据，一组是视频，一组是音频。如图所示：
- ![image](https://raw.githubusercontent.com/richardissuperman/videoconcepts/master/image4/2.png)



### 4.视频文件基本概念
#### 4.1 帧率
- **每秒显示的图片数**。影响画面流畅度，与画面流畅度成正比：帧率越大，画面越流畅；帧率越小，画面越有跳动感。由于人类眼睛的特殊生理结构，如果所看画面之帧率高于16的时候，就会认为是连贯的，此现象称之为视觉暂留。并且当帧速达到一定数值后，再增长的话，人眼也不容易察觉到有明显的流畅度提升了。


#### 4.2 分辨率
- (矩形)图片的长度和宽度，即图片的尺寸


#### 4.3 码率
- 把每秒显示的图片进行压缩后的数据量。影响体积，与体积成正比：码率越大，体积越大；码率越小，体积越小。 （体积=码率×时间）　　
- 帧率X分辨率=压缩前的每秒数据量(单位应该是若干个字节) 　　
- 压缩比=压缩前的每秒数据量/码率 （对于同一个视频源并采用同一种视频编码算法，则：压缩比越高，画面质量越差。）


#### 4.4 这些概念联系
- 所谓“清晰”，是指画面十分细腻，没有马赛克。并不是分辨率越高图像就越清晰。　　简单说：在码率一定的情况下，分辨率与清晰度成反比关系：分辨率越高，图像越不清晰，分辨率越低，图像越清晰。在分辨率一定的情况下，码率与清晰度成正比关系，码率越高，图像越清晰；码率越低，图像越不清晰。　　
- 但是，事实情况却不是这么简单。可以这么说：在码率一定的情况下，分辨率在一定范围内取值都将是清晰的；同样地，在分辨率一定的情况下，码率在一定范围内取值都将是清晰的。　　在视频压缩的过程中， I帧是帧内图像数据压缩，是独立帧。而P帧则是参考I帧进行帧间图像数据压缩，不是独立帧。在压缩后的视频中绝大多数都是P帧，故视频质量主要由P帧表现出来。由于P帧不是独立帧，而只是保存了与邻近的I帧的差值，故实际上并不存在分辨率的概念，应该看成一个二进制差值序列。而该二进制序列在使用熵编码压缩技术时会使用量化参数进行有损压缩，视频的质量直接由量化参数决定，而量化参数会直接影响到压缩比和码率。　　视频质量可以通过主观和客观方式来表现，主观方式就是通常人们提到的视频清晰度，而客观参数则是量化参数或者压缩比或者码率。在视频源一样，压缩算法也一样的前提下比较，量化参数，压缩比和码率之间是有直接的比例关系的。　　分辨率的变化又称为重新采样。由高分辨率变成低分辨率称为下采样，由于采样前数据充足，只需要尽量保留更多的信息量，一般可以获得相对较好的结果。而由低分辨率变成高分辨率称为上采样，由于需要插值等方法来补充（猜测）缺少的像素点，故必然会带有失真，这就是一种视频质量（清晰度）的损失。






#### 参考博客
- Android视频开发进阶：https://www.jianshu.com/p/10e357946447






















