#### **目录介绍**
- **1.音频开发具体涉及哪些业务**
- 1.1 音频播放[这个应该最多]
- 1.2 音频编辑，比如录音，裁剪等
- 1.3 音频算法处理，这个很难
- 1.4 音频的编解码和格式转换
- 1.5 音频压缩，变声，速率开发
- **2.了解一些基础概念**
- 2.1 采样率（samplerate）
- 2.2 声道数（channels）
- 2.3 音频帧（frame）
- **3.音频的压缩，编码与其他**
- 3.1 常见的音频压缩格式
- 3.2 常见的音频编码方式
- 3.3 音频开发相关的API
- 3.4 关于音频采集录制
- **4.音频播放常用方法介绍**
- 4.1 MediaPlayer的常用方法
- 4.2 MediaPlayer的几个监听方式
- 4.3 MediaPlayer设置播放源方法
- 4.4 MediaPlayer方法周期图
- 4.5 MediaPlayer生命周期分析
- **5.其他问题说明**
- 5.1 版本更新情况
- 5.2 参考链接
- 5.2 个人博客


### 1.音频开发具体涉及哪些业务
#### 1.1 音频播放[这个应该最多]
- 可以直接看我的项目代码，基础播放功能有：播放，暂停，下一首，上一首；可以设置多种播放类型：顺序播放，随机播放，单曲循环

#### 1.2 音频编辑，比如录音，裁剪等
- 比如音频录音功能，录完后可以进行裁剪，比如喜马拉雅，懒人听书等等都有这个功能。

#### 1.3 音频算法处理，这个很难
- 目前音频算法处理的开源库有：speex、ffmpeg，webrtc等等。
- 可以使用FFmpeg框架，FFmpeg是一套可以用来记录、转换数字音频、视频，并能将其转化为流的开源计算机程序。采用LGPL或GPL许可证。它提供了录制、转换以及流化音视频的完整解决方案。
- 具体使用看官方网站：https://www.ffmpeg.org/

#### 1.4 音频的编解码和格式转换
- 直接参考该系列第五篇文章，很详细介绍了

#### 1.5 音频压缩，变声，速率开发
- 后期研究，有点复杂，也没找到什么好的案例


### 2.了解一些基础概念
#### 2.1 什么是采样率（samplerate）
- 采样就是把模拟信号数字化的过程，不仅仅是音频需要采样，所有的模拟信号都需要通过采样转换为可以用0101来表示的数字信号，示意图如下所示：
- 图片采集于网络，只是作为学习使用
![image](http://s4.51cto.com/wyfs02/M02/7C/F6/wKioL1bdXQviw_TBAAAVYm_x3gk862.gif)
- 蓝色代表模拟音频信号，红色的点代表采样得到的量化数值。
- 采样频率越高，红色的间隔就越密集，记录这一段音频信号所用的数据量就越大，同时音频质量也就越高。
- 根据奈奎斯特理论，采样频率只要不低于音频信号最高频率的两倍，就可以无损失地还原原始的声音。
- 通常人耳能听到频率范围大约在20Hz～20kHz之间的声音，为了保证声音不失真，采样频率应在40kHz以上。常用的音频采样频率有：8kHz、11.025kHz、22.05kHz、16kHz、37.8kHz、44.1kHz、48kHz、96kHz、192kHz等。

#### 2.2 声道数（channels）
- 音频的采集和播放是可以叠加的，因此，可以同时从多个音频源采集声音，并分别输出到不同的扬声器，故声道数一般表示声音录制时的音源数量或回放时相应的扬声器数量。
- 常见的有单声道（Mono）和双声道（Stereo）


#### 2.3 音频帧（frame）
- 音频跟视频很不一样，视频每一帧就是一张图像，而从上面的正玄波可以看出，音频数据是流式的，本身没有明确的一帧帧的概念，在实际的应用中，为了音频算法处理/传输的方便，一般约定俗成取2.5ms~60ms为单位的数据量为一帧音频。
- 这个时间被称之为“采样时间”，其长度没有特别的标准，它是根据编解码器和具体应用的需求来决定的，我们可以计算一下一帧音频帧的大小：
- 假设某通道的音频信号是采样率为8kHz，位宽为16bit，20ms一帧，双通道，则一帧音频数据的大小为：
- int size = 8000 x 16bit x 0.02s  x 2 = 5120 bit = 640 byte


### 3.音频的压缩与编码
#### 3.1 常见的音频压缩格式
- 首先简单介绍一下音频数据压缩的最基本的原理：因为有冗余信息，所以可以压缩。
- 频谱掩蔽效应： 人耳所能察觉的声音信号的频率范围为20Hz～20KHz，在这个频率范围以外的音频信号属于冗余信号。
- 时域掩蔽效应： 当强音信号和弱音信号同时出现时，弱信号会听不到，因此，弱音信号也属于冗余信号。
- 简单列出常见的音频压缩格式：MP3，AAC，OGG，WMA，Opus，FLAC，APE，m4a，AMR，等等


#### 3.2 常见的音频编码方式
- 模拟的音频信号转换为数字信号需要经过采样和量化，量化的过程被称之为编码，根据不同的量化策略，产生了许多不同的编码方式，常见的编码方式有：PCM 和 ADPCM，这些数据代表着无损的原始数字音频信号，添加一些文件头信息，就可以存储为WAV文件了，它是一种由微软和IBM联合开发的用于音频数字存储的标准，可以很容易地被解析和播放。
- 音频开发过程中，会经常涉及到WAV文件的读写，以验证采集、传输、接收的音频数据的正确性。


#### 3.3 音频开发相关的API
- 音频采集：  MediaRecoder，AudioRecord
- 音频播放：  SoundPool，MediaPlayer，AudioTrack 
- 音频编解码： MediaCodec
- NDK API：     OpenSL ES
- 目前此开源项目采用MediaPlayer播放音频，采集使用AudioRecord


#### 3.4 关于音频采集录制
- 这块没作为重点，如果想深入了解，可以参考大神博客：https://yq.aliyun.com/articles/8637
- 有点复杂……



### 4.音频播放常用方法介绍
#### 4.1 MediaPlayer的常用方法
- 当然这里仅仅只是列举了一些常用的方法
- 具体可以参考我的代码：https://github.com/yangchong211/YCAudioPlayer
- 注意同步加载和异步加载的区别：同步就是指一个进程在执行某个请求的时候，若该请求需要一段时间才能返回信息，那么这个进程将会一直等待下去，直到收到返回信息才继续执行下去；异步是指进程不需 要一直等下去，而是继续执行下面的操作，不管其他进程的状态。当有消息返回时系统 会通知进程进行处理，这样可以提高执行的效率。

```
MediaPlayer mp = new MediaPlayer();//新建一个的实例
1.setDataSource() //设置 资源 
2.start() throws IllegalStateException //开 始播放，如果没有预编译错过会报错 
3.stop() //停 止播放 
4.pause() //暂 停播放 
5.prepare()//同步加载 
6.prepareAsync()// 异步加载，完成后调用监听 7.isPlaying(); //本 地方法，判断播放状态 
8.seekTo(int msec) //本地方法，跳转到时间点 9.int getDuration(); //本 地方法，获取音乐总长度 
10.release() //释 放资源 
11.reset() //重 置MediaPlayer 
12.setLooping(boolean looping) //设 置循环 
13.public native boolean isLooping(); //判 断循环状态 
14.setVolume(float leftVolume, float rightVolume) 
/ /设置音量，左声道和右声道 
15.setVolume(float volume) //设 置音量
16.getDuration();//获得载入的音频的播放时长
```

#### 4.2 MediaPlayer的几个监听方式
- **这里只是展示部分内容，详细内容可以直接去GitHub看我的音频和视频开源案例：https://github.com/yangchong211**
- **4.2.1 异步加载完成时回调监听**

```
public void setOnPreparedListener(OnPreparedListener listener) 
异步监听，一般在异步预加载之前就要设置好。
```

- **4.2.2 播放完毕后回调监听**

```
public void setOnCompletionListener(OnCompletionListener listener) 
一般用于设置播放完毕后，播放下一首还是循环播放
```

- **4.2.3 跳转完成时的监听**

```
public void setOnSeekCompleteListener(OnSeekCompleteListener listener) 
一般用于监听进度突然改变的值的变化
```

- **4.2.4 更多信息可以直接参考我的代码案例**
- https://github.com/yangchong211/YCAudioPlayer
- https://github.com/yangchong211/YCVideoPlayer




#### 4.3 MediaPlayer设置播放源方法
```
setDataSource(String path)//指定装载path路径所代表的文件。
setDataSource(Context context, Uri uri, Map<String, String headers)//指定装载uri所代表的文件。
setDataSource(Context context, Uri uri)//指定装载uri所代表的文件。
setDataSource(FileDescriptor fd, long offset, long length)//指定装载fd所代表的文件中从offset开始长度为length的文件内容。
setDataSource(FileDescriptor fd)//指定装载fd所代表的文件。
```


#### 4.4 MediaPlayer方法周期图[摘自网络]
![image](https://upload-images.jianshu.io/upload_images/2556431-e04989851ff4c5f7.gif?imageMogr2/auto-orient/)


#### 4.5 MediaPlayer生命周期分析
```
MediaPlayer是基于状态的，只有在特定状态才能执行特定的方法。所以认清MediaPlayer生命周期十分重要的。

1、当MediaPlayer通过new方式进行初始化或MediaPlayer调用了reset()方法后，它就处于Idle状态。当调用了release()方法后，它就处于End状态。这两种状态之间是MediaPlayer对象的生命周期。
1.1、在一个新构建的MediaPlayer对象和一个调用了reset()方法的MediaPlayer对象之间有一个微小的但是十分重要的差别。
在处于Idle状态时，调用getCurrentPosition(), getDuration(), getVideoHeight(), getVideoWidth(), setAudioStreamType(int), setLooping(boolean), setVolume(float, float), pause(), start(), stop(), seekTo(int), prepare() 或者 prepareAsync() 方法都是编程错误。
当一个MediaPlayer对象刚被构建的时候，内部的播放引擎和对象的状态都没有改变，在这个时候调用以上的那些方法，框架将无法回调客户端程序注册的OnErrorListener.onError()方法；但若这个MediaPlayer对象调用了reset()方法之后，再调用以上的那些方法，内部的播放引擎就会回调客户端程序注册的OnErrorListener.onError()方法了，并将错误的状态传入。
1.2、一旦一个MediaPlayer对象不再被使用，应立即调用release()方法来释放在内部的播放引擎中与这个MediaPlayer对象关联的资源。资源可能包括如硬件加速组件的单态组件，若没有调用release()方法可能会导致之后的MediaPlayer对象实例无法使用这种单态硬件资源，从而退回到软件实现或运行失败。一旦MediaPlayer对象进入了End状态，它不能再被使用，也没有办法再迁移到其它状态。
1.3、使用new操作符创建的MediaPlayer对象处于Idle状态，而那些通过重载的create()便利方法创建的MediaPlayer对象却不是处于Idle状态。事实上，如果成功调用了重载的create()方法，那么这些对象已经是Prepare状态了。

2、在 一般情况下，由于种种原因一些播放控制操作可能会失败，如不支持的音频/视频格式，缺少隔行扫描的音频/视频，分辨率太高，流超时等等。因此，错误报告和恢复在这种情况下是非常重要的。有时，由于编程错误，在处于无效状态的情况下调用了一个播放控制操作可能发生。在所有这些错误条件下，内部的播放引擎会调用一个由客户端程序员提供的OnErrorListener.onError()方法。客户端程序员可以通过调用 MediaPlayer.setOnErrorListener（android.media.MediaPlayer.OnErrorListener）方法来注册OnErrorListener。
2.1、一旦发生错误，MediaPlayer对象会进入到Error状态。
2.2、为了重用一个处于Error状态的MediaPlayer对象，可以调用reset()方法来把这个对象恢复成Idle状态。
2.3、注册一个OnErrorListener来获知内部播放引擎发生的错误是好的编程习惯。
2.4、在不合法的状态下调用一些方法，如prepare()，prepareAsync()和setDataSource()方法会抛出IllegalStateException异常。

3、调 用setDataSource(FileDescriptor)方法，或setDataSource(String)方法，或 setDataSource(Context，Uri)方法，或setDataSource(FileDescriptor，long，long)方法会使处于Idle状态的对象迁移到Initialized状态。
3.1、若当此MediaPlayer处于其它的状态下，调用setDataSource()方法，会抛出IllegalStateException异常。
3.2、好的编程习惯是不要疏忽了调用setDataSource()方法的时候可能会抛出的IllegalArgumentException异常和IOException异常。

4、在开始播放之前，MediaPlayer对象必须要进入Prepared状态。
4.1、有两种方法（同步和异步）可以使MediaPlayer对象进入Prepared状态：要么调用prepare()方法（同步），此方法返回就表示该MediaPlayer对象已经进入了Prepared状态；要么调用prepareAsync()方法（异步），此方法会使此MediaPlayer对象进入Preparing状态并返回，而内部的播放引擎会继续未完成的准备工作。当同步版本返回时或异步版本的准备工作完全完成时就会调用客户端程序员提供的OnPreparedListener.onPrepared()监听方法。可以调用MediaPlayer.setOnPreparedListener(android.media.MediaPlayer.OnPreparedListener)方法来注册OnPreparedListener。
4.2、Preparing是一个中间状态，在此状态下调用任何具备影响的方法的结果都是未知的！
4.3、在不合适的状态下调用prepare()和prepareAsync()方法会抛出IllegalStateException异常。当MediaPlayer对象处于Prepared状态的时候，可以调整音频/视频的属性，如音量，播放时是否一直亮屏，循环播放等。

5、要开始播放，必须调用start()方法。当此方法成功返回时，MediaPlayer的对象处于Started状态。isPlaying()方法可以被调用来测试某个MediaPlayer对象是否在Started状态。
5.1、当处于Started状态时，内部播放引擎会调用客户端程序员提供的OnBufferingUpdateListener.onBufferingUpdate()回调方法，此回调方法允许应用程序追踪流播放的缓冲的状态。
5.2、对一个已经处于Started 状态的MediaPlayer对象调用start()方法没有影响。
6、播放可以被暂停，停止，以及调整当前播放位置。当调用pause()方法并返回时，会使MediaPlayer对象进入Paused状态。注意 Started与Paused状态的相互转换在内部的播放引擎中是异步的。所以可能需要一点时间在isPlaying()方法中更新状态，若在播放流内 容，这段时间可能会有几秒钟。
6.1、调用start()方法会让一个处于Paused状态的MediaPlayer对象从之前暂停的地方恢复播放。当调用start()方法返回的时候，MediaPlayer对象的状态会又变成Started状态。
6.2、对一个已经处于Paused状态的MediaPlayer对象pause()方法没有影响。

7、调用stop()方法会停止播放，并且还会让一个处于Started，Paused，Prepared或PlaybackCompleted状态的MediaPlayer进入Stopped状态。
7.1、对一个已经处于Stopped状态的MediaPlayer对象stop()方法没有影响。

8、调用seekTo()方法可以调整播放的位置。
8.1、seekTo(int)方法是异步执行的，所以它可以马上返回，但是实际的定位播放操作可能需要一段时间才能完成，尤其是播放流形式的音频/视频。当实际的定位播放操作完成之后，内部的播放引擎会调用客户端程序员提供的OnSeekComplete.onSeekComplete()回调方法。可以通过setOnSeekCompleteListener(OnSeekCompleteListener)方法注册。
8.2、注意，seekTo(int)方法也可以在其它状态下调用，比如Prepared，Paused和PlaybackCompleted状态。此外，目前的播放位置，实际可以调用getCurrentPosition()方法得到，它可以帮助如音乐播放器的应用程序不断更新播放进度

9、当播放到流的末尾，播放就完成了。
9.1、如果调用了setLooping(boolean)方法开启了循环模式，那么这个MediaPlayer对象会重新进入Started状态。
9.2、若没有开启循环模式，那么内部的播放引擎会调用客户端程序员提供的OnCompletion.onCompletion()回调方法。可以通过调用MediaPlayer.setOnCompletionListener(OnCompletionListener)方法来设置。内部的播放引擎一旦调用了OnCompletion.onCompletion()回调方法，说明这个MediaPlayer对象进入了PlaybackCompleted状态。
9.3、当处于PlaybackCompleted状态的时候，可以再调用start()方法来让这个MediaPlayer对象再进入Started状态。

```


### 5.其他问题说明
#### 5.1 版本更新情况
- v1.0.0 2017年11月14日
- v1.0.2 2018年1月28日


#### 5.2 参考链接
- Android音频知识介绍-从AndroidRecord看起：https://www.jianshu.com/p/8da3cf058c0f
- Android音频使用总结：http://blog.csdn.net/wenzhi20102321/article/details/53018738
- 大神之作，Android MP3录音实现：http://www.cnblogs.com/ct2011/p/4080193.html
- Android音频开发基础：http://blog.51cto.com/ticktick/1748506?spm=a2c4e.11153940.blogcont8637.16.305f9135xi03I2
- Android音频焦点机制深入理解：http://blog.csdn.net/wusuobupo/article/details/53034506
- Android音频框架笔记 ：https://www.jianshu.com/p/9481b1482367


#### 5.2 个人博客
- **github：** [https://github.com/yangchong211](https://github.com/yangchong211)
- **知乎：** [https://www.zhihu.com/people/yang-chong-69-24/pins/posts](https://www.zhihu.com/people/yang-chong-69-24/pins/posts)
- **简书：** [http://www.jianshu.com/u/b7b2c6ed9284](http://www.jianshu.com/u/b7b2c6ed9284)
- **csdn：** [http://my.csdn.net/m0_37700275](http://my.csdn.net/m0_37700275)
- **喜马拉雅听书：** [http://www.ximalaya.com/zhubo/71989305/](http://www.ximalaya.com/zhubo/71989305/)
- 泡在网上的日子：[http://www.jcodecraeer.com/member/content_list.php?channelid=1](http://www.jcodecraeer.com/member/content_list.php?channelid=1)
- 邮箱：yangchong211@163.com
- 阿里云博客：[https://yq.aliyun.com/users/article?spm=5176.100239.headeruserinfo.3.dT4bcV](https://yq.aliyun.com/users/article?spm=5176.100239.headeruserinfo.3.dT4bcV)






